static char rcsid[] = "$Id: prlsctn005.c,v 1.9 2003/10/24 03:44:00 a-hasega Exp $";
/* 
 * $RWC_Release: Omni-1.6a $
 * $RWC_Copyright:
 *  Omni Compiler Software Version 1.5-1.6
 *  Copyright (C) 2002 PC Cluster Consortium
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Omni Compiler Software Version 1.0-1.4
 *  Copyright (C) 1999, 2000, 2001.
 *   Tsukuba Research Center, Real World Computing Partnership, Japan.
 *  
 *  Please check the Copyright and License information in the files named
 *  COPYRIGHT and LICENSE under the top  directory of the Omni Compiler
 *  Software release kit.
 *  
 *  
 *  $
 */
/* parallel sections 005:
 * check implicit barrier at parallel sections.
 */

#include "omniConfig.h"
#include <omp.h>
#include "omni.h"


int	thds;
int	buf[3];


int	errors = 0;


void
clear ()
{
  int	i;

  for (i=0; i<3; i++) {
    buf[i] = -1;
  }
}


main ()
{
  thds = omp_get_max_threads ();
  if (thds == 1) {
    printf ("should be run this program on multi threads.\n");
    exit (0);
  }
  omp_set_dynamic (0);
  omp_set_num_threads (2);

  clear ();
  #pragma omp parallel sections
  {
    #pragma omp section
    {
      int id = omp_get_thread_num ();
      if (id == 0) {
	buf[0] = id;
	barrier (2);
      } else {
	barrier (2);
	waittime(1);
	buf[1] = id;
      }
    }

    #pragma omp section
    {
      int id = omp_get_thread_num ();
      if (id == 0) {
	buf[0] = id;
	barrier (2);
      } else {
	barrier (2);
	waittime(1);
	buf[1] = id;
      }
    }
  }

  if (buf[0] == -1) {
    errors += 1;
  }
  if (buf[1] == -1) {
    errors += 1;
  }


  if (errors == 0) {
    printf ("parallel sections 005 : SUCCESS\n");
    return 0;
  } else {
    printf ("parallel sections 005 : FAILED\n");
    return 1;
  }
}
