static char rcsid[] = "$Id: lstprvt023.c,v 1.3 2000/07/30 13:09:14 a-hasega Exp $";
/* 
 * $RWC_Release: Omni-1.6a $
 * $RWC_Copyright:
 *  Omni Compiler Software Version 1.5-1.6
 *  Copyright (C) 2002 PC Cluster Consortium
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Omni Compiler Software Version 1.0-1.4
 *  Copyright (C) 1999, 2000, 2001.
 *   Tsukuba Research Center, Real World Computing Partnership, Japan.
 *  
 *  Please check the Copyright and License information in the files named
 *  COPYRIGHT and LICENSE under the top  directory of the Omni Compiler
 *  Software release kit.
 *  
 *  
 *  $
 */
/* lastprivate 023 :
 * lastprivate ѿfor loop Υ󥿤˻ѡ
 */
#include "omniConfig.h"
#include <omp.h>
#include "omni.h"


#define	LOOPNUM	103

int	errors = 0;
int	thds;

int	prvt;


main ()
{
  int	sum;

  thds = omp_get_max_threads ();
  if (thds == 1) {
    printf ("should be run this program on multi threads.\n");
    exit (0);
  }
  omp_set_dynamic (0);


  sum = 0;
  #pragma omp parallel 
  {
    #pragma omp for lastprivate(prvt) 
    for (prvt=0; prvt<LOOPNUM; prvt ++) {
      #pragma omp critical
      sum += 1;
    }
  }
  if (sum != LOOPNUM) {
    errors += 1;
  }
  if (prvt != LOOPNUM) {
    errors += 1;
  }


  sum = 0;
  #pragma omp parallel 
  {
    #pragma omp for schedule(static) lastprivate(prvt)
    for (prvt=0; prvt<LOOPNUM; prvt ++) {
      #pragma omp critical
      sum += 1;
    }
  }
  if (sum != LOOPNUM) {
    errors += 1;
  }
  if (prvt != LOOPNUM) {
    errors += 1;
  }


  sum = 0;
  #pragma omp parallel 
  {
    #pragma omp for schedule(dynamic) lastprivate(prvt)
    for (prvt=0; prvt<LOOPNUM; prvt ++) {
      #pragma omp critical
      sum += 1;
    }
  }
  if (sum != LOOPNUM) {
    errors += 1;
  }
  if (prvt != LOOPNUM) {
    errors += 1;
  }


  sum = 0;
  #pragma omp parallel 
  {
    #pragma omp for schedule(guided) lastprivate(prvt)
    for (prvt=0; prvt<LOOPNUM; prvt ++) {
      #pragma omp critical
      sum += 1;
    }
  }
  if (sum != LOOPNUM) {
    errors += 1;
  }
  if (prvt != LOOPNUM) {
    errors += 1;
  }


  sum = 0;
  #pragma omp parallel 
  {
    #pragma omp for schedule(runtime) lastprivate(prvt)
    for (prvt=0; prvt<LOOPNUM; prvt ++) {
      #pragma omp critical
      sum += 1;
    }
  }
  if (sum != LOOPNUM) {
    errors += 1;
  }
  if (prvt != LOOPNUM) {
    errors += 1;
  }


  if (errors == 0) {
    printf ("lastprivate 023 : SUCCESS\n");
    return 0;
  } else {
    printf ("lastprivate 023 : FAILED\n");
    return 1;
  }
}
