static char rcsid[] = "$Id: thdprvt026.c,v 1.4 2000/07/30 13:09:31 a-hasega Exp $";
/* 
 * $RWC_Release: Omni-1.6a $
 * $RWC_Copyright:
 *  Omni Compiler Software Version 1.5-1.6
 *  Copyright (C) 2002 PC Cluster Consortium
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Omni Compiler Software Version 1.0-1.4
 *  Copyright (C) 1999, 2000, 2001.
 *   Tsukuba Research Center, Real World Computing Partnership, Japan.
 *  
 *  Please check the Copyright and License information in the files named
 *  COPYRIGHT and LICENSE under the top  directory of the Omni Compiler
 *  Software release kit.
 *  
 *  
 *  $
 */
/* threadprivate 026 : 
 * threadprivate $BJQ?t$r%k!<%W%+%&%s%?$K;HMQ$7$?>l9g(B
 */

#include "omniConfig.h"
#include <omp.h>
#include "omni.h"


#define LOOPNUM		(100*thds)

int	errors = 0;
int	thds;
int	*buff;


int	prvt;
#pragma omp threadprivate(prvt)


void
check(int s)
{
  int   i,j, id;

  for (i=0; i<LOOPNUM; i+=s) {
    id = (i/s) % thds;

    for (j=0; j<s; j++) {
      if ((i+j) < LOOPNUM) {
        if (buff[i+j] != id) {
          #pragma omp critical
          errors += 1;
        }
      }
    }
  }
}


main ()
{
  int	ln;

  thds = omp_get_max_threads ();
  if (thds == 1) {
    printf ("should be run this program on multi threads.\n");
    exit (0);
  }
  buff = (int *)malloc(sizeof(int) * LOOPNUM);
  if (buff == NULL) {
    printf ("can not allocate memory.\n");
  }
  omp_set_dynamic (0);
  ln = LOOPNUM;


  #pragma omp parallel
  {
    #pragma omp for schedule(static,ln/thds)
    for (prvt=0; prvt<LOOPNUM; prvt++) {
      buff[prvt] = omp_get_thread_num ();
    }
  }
  check (LOOPNUM/thds);

  #pragma omp parallel for schedule(static,ln/thds)
  for (prvt=0; prvt<LOOPNUM; prvt++) {
    buff[prvt] = omp_get_thread_num ();
  }
  check (LOOPNUM/thds);


  if (errors == 0) {
    printf ("threadprivate 026 : SUCCESS\n");
    return 0;
  } else {
    printf ("threadprivate 026 : FAILED\n");
    return 1;
  }
}
