static char rcsid[] = "$Id: flush003.c,v 1.5 2000/10/16 04:38:57 a-hasega Exp $";
/* 
 * $RWC_Release: Omni-1.6a $
 * $RWC_Copyright:
 *  Omni Compiler Software Version 1.5-1.6
 *  Copyright (C) 2002 PC Cluster Consortium
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Omni Compiler Software Version 1.0-1.4
 *  Copyright (C) 1999, 2000, 2001.
 *   Tsukuba Research Center, Real World Computing Partnership, Japan.
 *  
 *  Please check the Copyright and License information in the files named
 *  COPYRIGHT and LICENSE under the top  directory of the Omni Compiler
 *  Software release kit.
 *  
 *  
 *  $
 */
/* flush 003:
 * ѿ̾ꤵ줿 flush ưǧ
 */

#include "omniConfig.h"
#include <omp.h>
#include "omni.h"


int	errors = 0;
int	thds;

int	a, b, c;


void
clear ()
{
  a = 0;
  b = 0;
  c = 0;
}


void
func_flush ()
{
  int	id = omp_get_thread_num ();

  switch (id) {
  case 0:
    waittime (1);
    a = 1;
    b = 2;
    c = 3;
    #pragma omp flush (a,b)
    #pragma omp flush (c)
    while (a != 0 || b != 0 || c != 0) {
      #pragma omp flush (a)
      #pragma omp flush (b, c)
    }
    break;

  case 1:
    while (a == 0 || b == 0 || c == 0) {
      #pragma omp flush (a)
      #pragma omp flush (b)
      #pragma omp flush (c)
    }
    a = 0;
    b = 0;
    c = 0;
    #pragma omp flush (a,b,c)
    break;

  default:
    break;
  }
}


main ()
{
  thds = omp_get_max_threads ();
  if (thds == 1) {
    printf ("should be run this program on multi threads.\n");
    exit (0);
  }
  omp_set_dynamic (0);


  clear ();
  #pragma omp parallel
  {
    int	id = omp_get_thread_num ();

    switch (id) {
    case 0:
      waittime (1);
      a = 1;
      b = 2;
      c = 3;
      #pragma omp flush (a,b)
      #pragma omp flush (c)
      while (a != 0 || b != 0 || c != 0) {
        #pragma omp flush (a)
        #pragma omp flush (b, c)
      }
      break;

    case 1:
      while (a == 0 || b == 0 || c == 0) {
        #pragma omp flush (a)
        #pragma omp flush (b)
        #pragma omp flush (c)
      }
      a = 0;
      b = 0;
      c = 0;
      #pragma omp flush (a,b,c)
      break;

    default:
      break;
    }
  }
  clear ();

  #pragma omp parallel
  func_flush ();
  clear ();


  if (errors == 0) {
    printf ("flush 003 : SUCCESS\n");
    return 0;
  } else {
    printf ("flush 003 : FAILED\n");
    return 1;
  }
}
