static char rcsid[] = "$Id: ordrd004.c,v 1.6 2002/04/11 14:00:57 a-hasega Exp $";
/* 
 * $RWC_Release: Omni-1.6a $
 * $RWC_Copyright:
 *  Omni Compiler Software Version 1.5-1.6
 *  Copyright (C) 2002 PC Cluster Consortium
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Omni Compiler Software Version 1.0-1.4
 *  Copyright (C) 1999, 2000, 2001.
 *   Tsukuba Research Center, Real World Computing Partnership, Japan.
 *  
 *  Please check the Copyright and License information in the files named
 *  COPYRIGHT and LICENSE under the top  directory of the Omni Compiler
 *  Software release kit.
 *  
 *  
 *  $
 */
/* ordered 004:
 * static,dynamic,guided塼󥰤chunk
 * ꤷưǧ
 */

#include "omniConfig.h"
#include <omp.h>
#include "omni.h"


#if defined(__OMNI_SCASH__) || defined(__OMNI_SHMEM__)
#define LOOPNUM		(thds*10)
#else
#define LOOPNUM		(thds*100)
#endif



int	errors = 0;
int	thds;
int	cnt;


void
clear ()
{
  cnt = 0;
}


void
func_ordered (int i)
{
  #pragma omp ordered
  {

    if (cnt != i) {
      #pragma omp critical
      errors ++;
    }
    cnt ++;
  }
}


main ()
{
  int	chunk = 0;


  thds = omp_get_max_threads ();
  if (thds == 1) {
    printf ("should be run this program on multi threads.\n");
    exit (0);
  }
  omp_set_dynamic (0);

  for (chunk=1; chunk<=10; chunk+=1) {
    clear ();
    #pragma omp parallel
    {
      int	i;

      #pragma omp for schedule(static,chunk) ordered
      for (i=0;  i<LOOPNUM;  i++) {
	func_ordered (i);
      }
    }

    clear ();
    #pragma omp parallel
    {
      int	i;

      #pragma omp for schedule(dynamic,chunk) ordered
      for (i=0;  i<LOOPNUM;  i++) {
	func_ordered (i);
      }
    }


    clear ();
    #pragma omp parallel
    {
      int	i;

      #pragma omp for schedule(guided,chunk) ordered
      for (i=0;  i<LOOPNUM;  i++) {
	func_ordered (i);
      }
    }
  }


  if (errors == 0) {
    printf ("ordered 004 : SUCCESS\n");
    return 0;
  } else {
    printf ("ordered 004 : FAILED\n");
    return 1;
  }
}
